// Created By: Jeff & Chris Rackauckas
// The purpose of this file is to take the values from the CSV and create an array that holds all of the data to be used.
// DEPENDENCIES: globalFunctions.js

// The array that holds the csv file containing all of the data that the stations read.
// TODO:  Refactor a way to get rid of this variable, since it just gets deleted.
var stationReadings;
// The array that holds the csv file containing all of the information about the stations.
// TODO: Make the variable become nonoglobal.  Possibly wrap it as an object?
var stationInformation;
// Is used for syncing up the asyncronous GET calls.  The program can only continue when the flags are at the correct length.
var flags=0;



// This is the function that is called when the STATION_READINGS_CSV, STATION_INFORMATION_CSV, and MAP_VALUES_CSV files are properly parsed.
// If flags==3, that means that the 3 CSV files have been parsed.
function stationInformationParsed(){
	if(flags!=3) return;
	flags=0;
	setMapValues(mapValues);
	stationReadings=arrangeStationsByName(stationReadings);
	for(i in stationInformation){
		stationInformation[i].readings=stationReadings[stationInformation[i].StaCode];
		}
	delete(stationReadings);
	startTIndex = Array.apply(null, new Array(stationInformation.length)).map(Number.prototype.valueOf,0); //Sets startTIndex to an array of 0's of size stationInformation.length	
	updateDisplays();
}

function getData(){
	// Gets the file and parses it.  Sets the flag to true when it's finished running.
	ajax("GET", STATION_READINGS_CSV, function(serverResponse){stationReadings=parseCSVData(serverResponse, stationInformationParsed); });
	ajax("GET", STATION_INFORMATION_CSV, function(serverResponse){stationInformation=parseCSVData(serverResponse, stationInformationParsed); });
	ajax("GET", MAP_VALUES_CSV, function(serverResponse){mapValues=parseCSVData(serverResponse, stationInformationParsed); });
}


// Currently returning as an associative array for ease of use later on in the program.
// If time becomes a factor, it will be switched to an array with constants to represent the different rows.
function parseCSVData(CSVData, callback){
	CSVData=CSVData.replace('\r\n','\n'); //Account for windows line breaks.
	CSVData=CSVData.split('\n');
	var index=CSVData[0].split('\t');
	var returnArray=new Array();
	// Currently looking at creating the index to be the name of the parameter for ease of use.
	// Should run at O(k*n) where k is the number of stations, and n is the number of parameters, not as bad as it looks.
	for(var i=1; i<CSVData.length; i++){
		var row=new Array();
		var stationData=CSVData[i].split('\t');
		for(var j=0; j<index.length; j++){
			row[index[j]]=stationData[j];
		}
		returnArray.push(row);
	}
	flags++;
	setTimeout(callback, 5);
	return returnArray;
}

// Is passed an array containing a set of stations, and returns an array where all of station data with the same station name are grouped together.
function arrangeStationsByName(stationArray){
	var arrangedArray=new Array();
	 for(var i=0; i<stationArray.length; i++){
		 if(arrangedArray[stationArray[i].StationName]!=undefined) arrangedArray[stationArray[i].StationName].push(stationArray[i]);
		 else{
			 arrangedArray[stationArray[i].StationName]=new Array();
			 arrangedArray[stationArray[i].StationName].push(stationArray[i]);
			 }
	 }
	 return arrangedArray;
}

//Sets the initial values for the map from a csv file.
function setMapValues(mapValues){
	dataDescription=mapValues[0]["Description"];
	document.getElementById("dataset").innerHTML = dataDescription;
	curTime = moment(mapValues[0]["StartDate"]);
	defaultDay = mapValues[0]["StartDate"];
	startDate = moment(mapValues[0]["StartDate"]);
	endDate = moment(mapValues[0]["EndDate"]);
	scaleLarge = mapValues[0]["RedSize"];
	scaleMedium = mapValues[0]["YellowSize"];
	scaleSmall = mapValues[0]["GreenSize"];
	parameterThresholds["DO"] = [parseFloat(mapValues[0]["DOLow"]),parseFloat(mapValues[0]["DOHigh"])];
	parameterThresholds["CHLA"] = [parseFloat(mapValues[0]["CHLAHigh"]),parseFloat(mapValues[0]["CHLALow"])];
	parameterThresholds["TDN"] = [parseFloat(mapValues[0]["TDNHigh"]),parseFloat(mapValues[0]["TDNLow"])];
	parameterThresholds["TDP"] = [parseFloat(mapValues[0]["TDPHigh"]),parseFloat(mapValues[0]["TDPLow"])];
	parameterThresholds["NO23"] = [parseFloat(mapValues[0]["NO23High"]),parseFloat(mapValues[0]["NO23Low"])];
}